-- TODO:
-- States for the following:

-- Crouching -> Crouching .. (until it's set to be not crouching, i.e. via not pressing a key)
-- Spin attack (pressing spin for it to activate) -> ?
-- Fastfalling -> Fastfalling .. (until player reaches ground)

-- if Airgrab attempt failed -> Falling state
-- if Airgrab attempt succeeded against another player -> Airgrabbing state
		-- Opponent: In airgrabbed state
	-- if Airgrabbing state and falling into the ground (with opponent) -> small hop backwards? state
		-- Opponent: Gets hurt
-- if Airgrab attempt succeded against the wall -> Cling on it
	-- Can jump off, but can't cling again to another wall

-- NOTE: using Lua instead of a custom state for idle animation
--freeslot("S_PLAY_HIDLE")
freeslot("S_PLAY_HCROUCH")

------------Attacks----------
freeslot("S_PLAY_HFASTFALL")-- Fastfall attack

freeslot("S_PLAY_HBKFLP1")	-- backflip kick
freeslot("S_PLAY_HBKFLP2")
freeslot("S_PLAY_HBKFLP3")
freeslot("S_PLAY_HBKFLP4")
freeslot("S_PLAY_HBKFLP5")

freeslot("S_PLAY_HDIVE1") 	-- Dive
freeslot("S_PLAY_HDIVE2") 
freeslot("S_PLAY_HDIVE3") 
freeslot("S_PLAY_HDIVE4") 

--- Airgrab
-- Airgrab state (attempt)
freeslot("S_PLAY_AIRGRAB_ATTEMPT")
-- Airgrab state (against player)
freeslot("S_PLAY_AIRGRAB_PLAYER")
	-- Player hurt state
	freeslot("S_PLAY_ENEMY_AIRGRAB_PLAYER")
-- Airgrab state (hopping back after opponent was slammed down)
freeslot("S_PLAY_AIRGRAB_AFTERMATH")
	-- Player gets hurt after this
-- Clinging to wall
freeslot("S_PLAY_AIRGRAB_WALL")
----------------------------

-- Aesthetic attack 1
freeslot("S_PLAY_AESTH_KICK1A")
freeslot("S_PLAY_AESTH_KICK1B")
-- Aesthetic attack 2
freeslot("S_PLAY_AESTH_KICK2")
-- Aesthetic attack 3
freeslot("S_PLAY_AESTH_KICK3")

--==Credit: Bloopsdoob=======
-- Death states
freeslot(
"S_PLAY_HONEY_DIE_FIRE",  	-- by fire
"S_PLAY_HONEY_DIE_ELEC",	-- by electricity
"S_PLAY_HONEY_DIE_NUKE",	-- by nuke
"S_PLAY_HONEY_DIE_NUKE_GIB",-- nuke 'gibs'
"MT_HONEY_NUKE_GIB"			-- nuke 'gib' object
)
--=========================


	-- TODO: replace all long definition states with short definition ones
	-- because you can avoid syntax errors this way |:|
	
-- Default idle animation (don't use S_PLAY_STND pls)
--states[S_PLAY_HIDLE] = {
--	sprite = SPR_PLAY,
--	frame = FF_ANIMATE|SPR2_STND|A,
--	tics = -1,
	--action?
--	var1 = 4,
--	var2 = 6
--}

--states[S_PLAY_HCROUCH] = {SPR_PLAY, SPR2_CRCH|A, 4, nil, 0, 0, S_PLAY_HCROUCH}

states[S_PLAY_HCROUCH] = {
	sprite = SPR_PLAY,
	frame = FF_ANIMATE|SPR2_CRCH|A,
	tics = -1,
	--action?
	var1 = 4,
	var2 = 6
}

states[S_PLAY_HFASTFALL] = {
	sprite = SPR_PLAY,
	frame = SPR2_FALL|A, --|FF_ANIMATE
	tics = -1,
	--action?
	var1 = 0,
	var2 = 0
}

states[S_PLAY_HBKFLP1] = {
	sprite = SPR_PLAY,
	frame = SPR2_BKCK|FF_ANIMATE|A,
	tics = 12,
	var1 = 3,
	var2 = 4,
	nextstate = S_PLAY_FALL
}

--states[S_PLAY_HBKFLP2] = {
--	sprite = SPR_PLAY,
--	frame = SPR2_BKCK|B,
--	tics = 4,
	--action?
--	nextstate = S_PLAY_HBKFLP3
--}

--states[S_PLAY_HBKFLP3] = {
--	sprite = SPR_PLAY,
--	frame = SPR2_BKCK|C,
--	tics = 5,
	--action?
--	nextstate = S_PLAY_HBKFLP4
--}

--states[S_PLAY_HBKFLP4] = {
--	sprite = SPR_PLAY,
--	frame = SPR2_BKCK|D,
--	tics = 4,
--	nextstate = S_PLAY_FALL
--}

states[S_PLAY_AESTH_KICK1A] = {
    sprite = SPR_PLAY,
    frame = SPR2_KCK1|A,
    tics = 4,
    nextstate = S_PLAY_AESTH_KICK1B
}

states[S_PLAY_AESTH_KICK1B] = {
    sprite = SPR_PLAY,
    frame = SPR2_KCK1|B,
    tics = 15,
	nextstate = S_PLAY_FALL
}

states[S_PLAY_HDIVE1] = {
	sprite = SPR_PLAY,
	frame = SPR2_DIVE|FF_ANIMATE|A,
	tics = 6,
	var1 = 1,
	var2 = 3,
	nextstate = S_PLAY_HDIVE2
}

states[S_PLAY_HDIVE2] = {
	sprite = SPR_PLAY,
	frame = SPR2_DIVE|C,
	tics = -1
}

--========Credit: Bloopsdoob=====
states[S_PLAY_HONEY_DIE_FIRE] = {SPR_PLAY, SPR2_ADIE, -1, nil, 0, 0, S_NULL}
states[S_PLAY_HONEY_DIE_NUKE] = {SPR_PLAY, SPR2_ADIE, -1, nil, 0, 0, S_NULL}
states[S_PLAY_HONEY_DIE_NUKE_GIB] = {SPR_PLAY, SPR2_GIB_, -1, nil, 0, 0, S_NULL}
states[S_PLAY_HONEY_DIE_ELEC] = {SPR_PLAY, SPR2_ADIE, 2, nil, 0, 0, S_PLAY_HONEY_DIE_ELEC}

mobjinfo[MT_HONEY_NUKE_GIB] = {
    spawnstate = S_NULL,
    spawnhealth = 0,
    deathstate = S_NULL,
    speed = FRACUNIT,
    radius = 2*FRACUNIT,
    height = 2*FRACUNIT,
    flags = MF_SCENERY
}
--===============================